//import morgan from "morgan";
import express from "express";
import cors from "cors";
///importaciones de los routers
import {apiUser} from './src/user/index.js';
import {apiSucursal} from './src/sucursal/index.js';
import {apiCalidad} from './src/calidad/index.js';
import {apiMedida} from './src/ancho/index.js';
import {apiUnidadMedida} from './src/unidadMedida/index.js';
import {apiTela} from './src/tela/index.js';
// Importacion del archivo 
//import { Config } from './src/config/config.js';


const app = express();

// configuracion de puerto 
//const puerto = Config.port ? Config.port : 4000;


// middelware 
app.use(express.json());
app.use(cors());
app.use(express.urlencoded({extended:false}));


// uso de rutas
apiUser(app);
apiSucursal(app);
apiCalidad(app);
apiMedida(app);
apiUnidadMedida(app);
apiTela(app);


// Ejecutar el servicio
app.listen(3000, () => {
    console.log("Server is running***");
})


//Ejecutando el servicio utilizando el archivo .env
//app.listen(Config.port, () => {
//    console.log("Server is running***");
//})