//importando Response
import{Response} from "../common/Response.js";
import { connection } from "../config/db.js";
import { AppError } from "../utils/appError.js";

const anchoController = {

  getAncho: (req,res, next)=>{
    
    connection.query("SELECT * FROM ancho", function (err, data, fields) {
       if(err) return next(new AppError(err))
       res.status(200).json({
         status: "success",
         length: data?.length,
         data: data,
       });
     });
    },
   
    getAnchoById: (req, res, next) => {
     if (!req.params.id) {
       return next(new AppError("No todo id found", 404));
     }
     connection.query(
       "SELECT * FROM ancho WHERE id = ?",
       [req.params.id],
       function (err, data, fields) {
         if (err) return next(new AppError(err, 500));
         res.status(200).json({
           status: "success",
           length: data?.length,
           data: data,
         });
       }
     );
    },
    


 postAncho: (req, res, next) => {
   if (!req.body) return next(new AppError("Formulario no encontrado", 404));
   const values = [req.body.medida];
   connection.query(
     "INSERT INTO ancho (ancho) VALUES(?)",
     [values],
     function (err, data, fields) {
       if (err) return next(new AppError(err, 500));
       res.status(201).json({
         status: "success",
         message: "Datos Guardados",
       });
     }
   );
  },

   
   deleteAncho: (req, res, next) => {
     if (!req.params.id) {
       return next(new AppError("No se ha encontrado", 404));
     }
     connection.query(
       "DELETE FROM ancho WHERE id=?",
       [req.params.id],
       function (err, fields) {
         if (err) return next(new AppError(err, 500));
         res.status(201).json({
           status: "success",
           message: "Datos Eliminados!",
         });
       }
     );
   
   },

   putAncho: (req, res, next) => {
     if (!req.params.id) {
       return next(new AppError("No se ha encontrado", 404));
     }
     const medida = [req.body.medida];
     connection.query(
      "UPDATE ancho SET ancho ='" + medida +"' WHERE id=?",
       [req.params.id],
       function (err, data, fields) {
         if (err) return next(new AppError(err, 500));
         res.status(201).json({
           status: "success",
           message: "Datos Actualizados",
         });
       }
     );
    }
};

export { anchoController };