//importando Response
import{Response} from "../common/Response.js";
import { connection } from "../config/db.js";
import { AppError } from "../utils/appError.js";

const calidadController = {

  getCalidad: (req,res, next)=>{
    
    connection.query("SELECT * FROM calidad", function (err, data, fields) {
       if(err) return next(new AppError(err))
       res.status(200).json({
         status: "success",
         length: data?.length,
         data: data,
       });
     });
    },
   
    getCalidadById: (req, res, next) => {
     if (!req.params.id) {
       return next(new AppError("No todo id found", 404));
     }
     connection.query(
       "SELECT * FROM calidad WHERE id = ?",
       [req.params.id],
       function (err, data, fields) {
         if (err) return next(new AppError(err, 500));
         res.status(200).json({
           status: "success",
           length: data?.length,
           data: data,
         });
       }
     );
    },
    


 postCalidad: (req, res, next) => {
   if (!req.body) return next(new AppError("Formulario no encontrado", 404));
   const values = [req.body.codigo, req.body.descripcion];
   connection.query(
     "INSERT INTO calidad (codigo, description) VALUES(?)",
     [values],
     function (err, data, fields) {
       if (err) return next(new AppError(err, 500));
       res.status(201).json({
         status: "success",
         message: "Datos Guardados",
       });
     }
   );
  },

   
   deleteCalidad: (req, res, next) => {
     if (!req.params.id) {
       return next(new AppError("No se ha encontrado", 404));
     }
     connection.query(
       "DELETE FROM calidad WHERE id=?",
       [req.params.id],
       function (err, fields) {
         if (err) return next(new AppError(err, 500));
         res.status(201).json({
           status: "success",
           message: "Datos Eliminados!",
         });
       }
     );
   
   },

   putCalidad: (req, res, next) => {
     if (!req.params.id) {
       return next(new AppError("No se ha encontrado", 404));
     }
     const codigo = [req.body.codigo];
      const descripcion = [req.body.descripcion];
     connection.query(
      "UPDATE calidad SET codigo ='" + codigo +"', description='" + descripcion +"' WHERE id=?",
       [req.params.id],
       function (err, data, fields) {
         if (err) return next(new AppError(err, 500));
         res.status(201).json({
           status: "success",
           message: "Datos Actualizados",
         });
       }
     );
    }
};

export { calidadController };