//importando Response
import{Response} from "../common/Response.js";
import { connection } from "../config/db.js";
import { AppError } from "../utils/appError.js";

const sucursalController = {

  getSucursal: (req,res, next)=>{
    
    connection.query("SELECT * FROM sucursal", function (err, data, fields) {
       if(err) return next(new AppError(err))
       res.status(200).json({
         status: "success",
         length: data?.length,
         data: data,
       });
     });
    },
   
    getSucursalById: (req, res, next) => {
     if (!req.params.id) {
       return next(new AppError("No todo id found", 404));
     }
     connection.query(
       "SELECT * FROM sucursal WHERE id = ?",
       [req.params.id],
       function (err, data, fields) {
         if (err) return next(new AppError(err, 500));
         res.status(200).json({
           status: "success",
           length: data?.length,
           data: data,
         });
       }
     );
    },
    


 postSucursal: (req, res, next) => {
   if (!req.body) return next(new AppError("Formulario no encontrado", 404));
   const values = [req.body.nombre, req.body.direccion];
   connection.query(
     "INSERT INTO sucursal (nombre, direccion) VALUES(?)",
     [values],
     function (err, data, fields) {
       if (err) return next(new AppError(err, 500));
       res.status(201).json({
         status: "success",
         message: "Datos Guardados",
       });
     }
   );
  },

   
   deleteSucursal: (req, res, next) => {
     if (!req.params.id) {
       return next(new AppError("No se ha encontrado", 404));
     }
     connection.query(
       "DELETE FROM sucursal WHERE id=?",
       [req.params.id],
       function (err, fields) {
         if (err) return next(new AppError(err, 500));
         res.status(201).json({
           status: "success",
           message: "Datos Eliminados!",
         });
       }
     );
   
   },

   putSucursal: (req, res, next) => {
     if (!req.params.id) {
       return next(new AppError("No se ha encontrado", 404));
     }
     const nombre = [req.body.nombre];
      const direccion = [req.body.direccion];
     connection.query(
      "UPDATE sucursal SET nombre='" + nombre +"', direccion='" + direccion +"' WHERE id=?",
       [req.params.id],
       function (err, data, fields) {
         if (err) return next(new AppError(err, 500));
         res.status(201).json({
           status: "success",
           message: "Datos Actualizados",
         });
       }
     );
    }
};

export { sucursalController };