//importando Response
import { response } from "express";
import{Response} from "../common/Response.js";
import { connection } from "../config/db.js";
import { AppError } from "../utils/appError.js";

const telaController = {

    getTela: (req,res, next)=>{
    
     connection.query("SELECT * FROM tela", function (err, data, fields) {
        if(err) return next(new AppError(err))
        res.status(200).json({
          status: "success",
          length: data?.length,
          data: data,
        });
      });
     },
    
     getTelaById: (req, res, next) => {
      if (!req.params.id) {
        return next(new AppError("No todo id found", 404));
      }
      connection.query(
        "SELECT * FROM tela WHERE id = ?",
        [req.params.id],
        function (err, data, fields) {
          if (err) return next(new AppError(err, 500));
          res.status(200).json({
            status: "success",
            length: data?.length,
            data: data,
          });
        }
      );
     },
     
     getTelaByLocation: (req, res, next) => {
      if (!req.params.id) {
        return next(new AppError("No todo id found", 404));
      }
      connection.query(
        "SELECT * FROM tela WHERE sucursal_id = ?",
        [req.params.id],
        function (err, data, fields) {
          if (err) return next(new AppError(err, 500));
          res.status(200).json({
            status: "success",
            length: data?.length,
            data: data,
          });
        }
      );
     },

  postTela: (req, res, next) => {
    if (!req.body) return next(new AppError("Formulario no encontrado", 404));
    const values = [req.body.item, req.body.cantidad, req.body.descripcion, req.body.ancho, req.body.unidadMedida, 
                    req.body.sucursal, req.body.calidad, req.body.usuario, req.body.costoUnitario, req.body.status];
    connection.query(
      "INSERT INTO tela (item, cantidad, descripcion, ancho_id, umedida_id, sucursal_id, calidad_id, user_id, costo_unitario, status) VALUES(?)",
      [values],
      function (err, data, fields) {
        if (err) return next(new AppError(err, 500));
        res.status(201).json({
          status: "success",
          message: "Datos Guardados",
        });
      }
    );
   },

    
    deleteTela: (req, res, next) => {
      if (!req.params.id) {
        return next(new AppError("No se ha encontrado", 404));
      }
      connection.query(
        "DELETE FROM tela WHERE id=?",
        [req.params.id],
        function (err, fields) {
          if (err) return next(new AppError(err, 500));
          res.status(201).json({
            status: "success",
            message: "Datos Eliminados!",
          });
        }
      );
    
    },

    putTela: (req, res, next) => {
      if (!req.params.id) {
        return next(new AppError("No se ha encontrado", 404));
      }
      const item = [req.body.item];
      const cantidad = [req.body.cantidad];
      const descripcion = [req.body.descripcion];
      const sucursal = [req.body.sucursal];
      const calidad = [req.body.calidad];
      
      connection.query(
        "UPDATE tela SET item='" + item +"', cantidad='" + cantidad +"', descripcion='" 
        + descripcion +"', sucursal_id ='" + sucursal +"', calidad_id='" + calidad +"' WHERE id=?",
        [req.params.id],
        function (err, data, fields) {
          if (err) return next(new AppError(err, 500));
          res.status(201).json({
            status: "success",
            message: "Datos Actualizados",
          });
        }
      );
     }
};






export { telaController };
