//importando Response
import{Response} from "../common/Response.js";
import { connection } from "../config/db.js";
import { AppError } from "../utils/appError.js";

const unidadMedidaController = {

  getUnidadMedida: (req,res, next)=>{
    
    connection.query("SELECT * FROM umedida", function (err, data, fields) {
       if(err) return next(new AppError(err))
       res.status(200).json({
         status: "success",
         length: data?.length,
         data: data,
       });
     });
    },
   
    getUnidadMedidaById: (req, res, next) => {
     if (!req.params.id) {
       return next(new AppError("No todo id found", 404));
     }
     connection.query(
       "SELECT * FROM umedida WHERE id = ?",
       [req.params.id],
       function (err, data, fields) {
         if (err) return next(new AppError(err, 500));
         res.status(200).json({
           status: "success",
           length: data?.length,
           data: data,
         });
       }
     );
    },
    


 postUnidadMedida: (req, res, next) => {
   if (!req.body) return next(new AppError("Formulario no encontrado", 404));
   const values = [req.body.unidadMedida];
   connection.query(
     "INSERT INTO umedida (medida) VALUES(?)",
     [values],
     function (err, data, fields) {
       if (err) return next(new AppError(err, 500));
       res.status(201).json({
         status: "success",
         message: "Datos Guardados",
       });
     }
   );
  },

   
   deleteUnidadMedida: (req, res, next) => {
     if (!req.params.id) {
       return next(new AppError("No se ha encontrado", 404));
     }
     connection.query(
       "DELETE FROM umedida WHERE id=?",
       [req.params.id],
       function (err, fields) {
         if (err) return next(new AppError(err, 500));
         res.status(201).json({
           status: "success",
           message: "Datos Eliminados!",
         });
       }
     );
   
   },

   putUnidadMedida: (req, res, next) => {
     if (!req.params.id) {
       return next(new AppError("No se ha encontrado", 404));
     }
     const medida = [req.body.unidadMedida];
     connection.query(
      "UPDATE umedida SET medida ='" + medida +"' WHERE id=?",
       [req.params.id],
       function (err, data, fields) {
         if (err) return next(new AppError(err, 500));
         res.status(201).json({
           status: "success",
           message: "Datos Actualizados",
         });
       }
     );
    }
};

export { unidadMedidaController };