//importando Response
import{Response} from "../common/Response.js";
import { connection } from "../config/db.js";
import { AppError } from "../utils/appError.js";
import { getUsersAll } from "./service.js";
//const getUsersAll = require("./service.js");
const userController = {

    getDatos: (req,res, next)=>{
    
     connection.query("SELECT * FROM sucursal", function (err, data, fields) {
        if(err) return next(new AppError(err))
        res.status(200).json({
          status: "success",
          length: data?.length,
          data: data,
        });
      });
     },
    
     getDatosById: (req, res, next) => {
      if (!req.params.id) {
        return next(new AppError("No todo id found", 404));
      }
      connection.query(
        "SELECT * FROM sucursal WHERE id = ?",
        [req.params.id],
        function (err, data, fields) {
          if (err) return next(new AppError(err, 500));
          res.status(200).json({
            status: "success",
            length: data?.length,
            data: data,
          });
        }
      );
     },
     


  postDatos: (req, res, next) => {
    if (!req.body) return next(new AppError("Formulario no encontrado", 404));
    const values = [req.body.nombre, req.body.direccion];
    connection.query(
      "INSERT INTO sucursal (nombre, direccion) VALUES(?)",
      [values],
      function (err, data, fields) {
        if (err) return next(new AppError(err, 500));
        res.status(201).json({
          status: "success",
          message: "Datos Guardados",
        });
      }
    );
   },

    
    deleteDatos: (req, res, next) => {
      if (!req.params.id) {
        return next(new AppError("No se ha encontrado", 404));
      }
      connection.query(
        "DELETE FROM sucursal WHERE id=?",
        [req.params.id],
        function (err, fields) {
          if (err) return next(new AppError(err, 500));
          res.status(201).json({
            status: "success",
            message: "Datos Eliminados!",
          });
        }
      );
    
    },

    putDatos: (req, res, next) => {
      if (!req.params.id) {
        return next(new AppError("No se ha encontrado", 404));
      }
      const values = [req.body.nombre];
      connection.query(
        "UPDATE sucursal SET nombre='. values .' WHERE id=?",
        [req.params.id],
        function (err, data, fields) {
          if (err) return next(new AppError(err, 500));
          res.status(201).json({
            status: "success",
            message: "Datos Actualizados",
          });
        }
      );
     }
};

export { userController };
//module.exports = userController;