//importando Response
import{Response} from "../common/Response.js";
import { connection } from "../config/db.js";
import { AppError } from "../utils/appError.js";

const userController = {

    getUser: (req,res, next)=>{
    
     connection.query("SELECT * FROM users", function (err, data, fields) {
        if(err) return next(new AppError(err))
        res.status(200).json({
          status: "success",
          length: data?.length,
          data: data,
        });
      });
     },
    
     getUserById: (req, res, next) => {
      if (!req.params.id) {
        return next(new AppError("No todo id found", 404));
      }
      connection.query(
        "SELECT * FROM users WHERE id = ?",
        [req.params.id],
        function (err, data, fields) {
          if (err) return next(new AppError(err, 500));
          res.status(200).json({
            status: "success",
            length: data?.length,
            data: data,
          });
        }
      );
     },

    

  postUser: (req, res, next) => {
    if (!req.body) return next(new AppError("Formulario no encontrado", 404));
    const values = [req.body.nombre, req.body.email, req.body.roll, req.body.password];
    connection.query(
      "INSERT INTO users (name, email, roll_id, password) VALUES(?)",
      [values],
      function (err, data, fields) {
        if (err) return next(new AppError(err, 500));
        res.status(201).json({
          status: "success",
          message: "Datos Guardados",
        });
      }
    );
   },

    
    deleteUser: (req, res, next) => {
      if (!req.params.id) {
        return next(new AppError("No se ha encontrado", 404));
      }
      connection.query(
        "DELETE FROM users WHERE id=?",
        [req.params.id],
        function (err, fields) {
          if (err) return next(new AppError(err, 500));
          res.status(201).json({
            status: "success",
            message: "Datos Eliminados!",
          });
        }
      );
    
    },

    putUser: (req, res, next) => {
      if (!req.params.id) {
        return next(new AppError("No se ha encontrado", 404));
      }
      const nombre = [req.body.nombre];
      const email = [req.body.email];
      const password = [req.body.password];
      connection.query(
        "UPDATE users SET name='" + nombre +"', email='" + email +"', password='" + password +"' WHERE id=?",
        [req.params.id],
        function (err, data, fields) {
          if (err) return next(new AppError(err, 500));
          res.status(201).json({
            status: "success",
            message: "Datos Actualizados",
          });
        }
      );
     }
};

export { userController };
